CC=pdflatex
# Needed by minted to call pygments.
BIB=bibtex
SPELLCHECK=aspell

PAPER=beamer.tex

TEX=$(wildcard content/*.tex)
AUX=$(wildcard *.aux)
FIGS_SVG=$(wildcard figs/SVG/*.svg)
FIGS_PDF=$(subst SVG,PDF,$(FIGS_SVG:.svg=.pdf))

# Get first PDF figure of FIGS_PDF with firstword then get its dirname with dir.
FIGS_PDF_DIR=$(dir $(firstword $(FIGS_PDF)))

all: $(FIGS_PDF)
	$(CC) $(PAPER)

GCC_MINOR=12

# For each figure in SVG convert it to PDF.
# We need to not export only the drawing for multiple figures.
# So, we call bash for that.
figs/PDF/%.pdf: figs/SVG/%.svg
	@if [ ! -d $(FIGS_PDF_DIR) ]; then mkdir $(FIGS_PDF_DIR); fi
	@if [ $< = 'figs/SVG/cgroups_lru.svg' -o $< = 'figs/SVG/lru.svg' -o $< = 'figs/SVG/buddy_allocator.svg' -o $< = 'figs/SVG/hypervisor_type1.svg' -o $< = 'figs/SVG/hypervisor_type2.svg' -o $< = 'figs/SVG/container.svg' -o $< = 'figs/SVG/dummy_transactions.svg' -o $< = 'figs/SVG/dummy_memory.svg' -o $< = 'figs/SVG/no_limit.svg' -o $< = 'figs/SVG/isolation.svg' -o $< = 'figs/SVG/consolidation.svg' -o $< = 'figs/SVG/memory_cache.svg' -o $< = 'figs/SVG/experiment_setup.svg' -o $< = 'figs/SVG/memoplight.svg' -o $< = 'figs/SVG/loop_user.svg' -o $< = 'figs/SVG/loop_kernel.svg' ]; then\
		echo 'python3 svg_export_fig.py -n $< -d figs/PDF';\
		python3 svg_export_fig.py -n $< -d figs/PDF;\
	else\
		echo 'python3 svg_export_fig.py $< -d figs/PDF';\
		python3 svg_export_fig.py $< -d figs/PDF;\
	fi

bib: $(AUX)
	for i in $^; do $(BIB) $$i; done

check: $(PAPER)
	# '-d fr' tells to use english dictionnary, '-t' is to use LaTeX mode
	# and '-c' is to check.
	for i in $^; do $(SPELLCHECK) -d fr -t -c $$i; done

clean:
	rm *.pdf *.aux *.bbl *.blg *.log *.out *.bcf *.lof *.lol *.lot *.toc *.xml

mr_proper: clean
	rm -r $(FIGS_PDF_DIR)